﻿using FlyADBase;
using FlyXray;
using GeneralGommunication;
using Misc;
using System;
using System.Windows;
using Unity;

namespace AD2021.B2.TestApp
{
    /// <summary>
    /// App.xaml 的交互逻辑
    /// </summary>
    public partial class App : Application
    {

        Unity.UnityContainer container;
        public App()
        {

            container = new Unity.UnityContainer();

            FlyAd2021B2 flyAd2021 = new FlyAd2021B2();
            if (!flyAd2021.Load())
                flyAd2021.Save();

            //flyAd2021.IsReadParamFromDev

            container.RegisterInstance(flyAd2021);



            ModbusAsciiAsyncConnector connector = new ModbusAsciiAsyncConnector("flyxray.json");
            connector.Load();
            connector.Modbus.logger = NLog.LogManager.GetLogger("FlyXray");
            //connector.comm_logger = connector.Modbus.logger;
            connector.Init();
            
            FlyXrayUnit flyXray01 = new FlyXrayUnit();
            flyXray01.Init(connector, TimeSpan.FromSeconds(0.5));
            flyXray01.ID = 1;

            container.RegisterInstance(connector);
            container.RegisterInstance(flyXray01);


            PollModule.Current.Start();



            this.Startup += App_Startup;
        }

        private void App_Startup(object sender, StartupEventArgs e)
        {
            MainWindow window = new MainWindow();
            this.MainWindow = window;

            container.BuildUp(window);
            window.Show();
        }


    }
}
