﻿using CommunityToolkit.Mvvm.Input;
using FlyXray;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace AD2021.B2.TestApp
{
    /// <summary>
    /// WdMotorParam.xaml 的交互逻辑
    /// </summary>
    public partial class WdFlyXrayParam : Window
    {
        WdFlyXrayParamVm viewModel;
        public WdFlyXrayParam()
        {
            InitializeComponent();
        }
        public void Init(string name, FlyXrayCore core)
        {
            viewModel = new WdFlyXrayParamVm();
            viewModel.Init(name, core, this);
            this.DataContext = viewModel;
        }
    }
    public class WdFlyXrayParamVm : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public string Name { get; set; }
        public int ID { get; set; }//485 ID 0~255
        public uint HvSet { get; set; }
        public uint IanSet { get; set; }
        public uint IlimSet { get; set; }
        public uint HvMax { get; set; }
        public uint IanMax { get; set; }
        public uint IpreSet { get; set; }


        public RelayCommand GetParamCmd { get; private set; }
        public RelayCommand SetParamCmd { get; private set; }

        FlyXrayCore core;
        Window w;
        
        public WdFlyXrayParamVm() 
        {
            GetParamCmd = new RelayCommand(GetParam);
            SetParamCmd = new RelayCommand(SetParam);
        }



        public void Init(string name, FlyXrayCore core,  Window w) 
        {
            Name = name;
            this.core = core;
            this.w = w;
            ID = core.ID;
            GetParam();
        }
        private void SetParam()
        {
            core.ID = ID;
            core.SetParam(HvSet, IanSet, IlimSet, HvMax, IanMax, IpreSet,
                (asyncContext,retData)=> {
                
                core.SaveParam((asyncContext2, retData2) => {
                    w.Dispatcher.Invoke(() =>
                    {
                        MessageBox.Show(w, "设置成功");
                    });
                },null);

            }, null);
        }

        private void GetParam()
        {
            core.GetParam((asyncContext, retData) =>
            {
                var response = retData as GetParam_Response;
                HvSet = response.HvSet;
                HvMax = response.HvMax;
                IanMax = response.IanMax;
                IanSet = response.IanSet;
                IlimSet = response.IlimSet;
                IpreSet = response.IpreSet;
                w.Dispatcher.Invoke(() =>
                        {
                            MessageBox.Show(w, "获取成功");
                        });
               
            }, this);
        }
    }
}