﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace Misc
{
    public static class HexAndStr
    {
        public static string Hex2Str2(byte[] buf)
        {
            string msg = "";
            for (int i = 0; i < buf.Count(); i++)
            {
                if (!string.IsNullOrEmpty(msg))
                    msg += " ";
                msg += $"{buf[i]:X2}";
            }
            return msg;
        }
        //等长翻译
        public static string Hex2Str3(byte[] buf)
        {
            string msg = "";
            for (int i = 0; i < buf.Count(); i++)
            {
                byte c = buf[i];
                if (i != 0)
                    msg += " ";
                if (c >= 0x21 && c <= 0x7e)
                    msg += $" {(char)c}";
                else
                    msg += "  ";
            }
            return msg;
        }

        public static string Hex2Str(byte[] buf)
        {
            string msg = "";
            for (int i = 0; i < buf.Count(); i++)
            {
                if (i != 0)
                    msg += " ";
                msg += $"{buf[i]:X2}";
            }
            msg += " [";
            for (int i = 0; i < buf.Count(); i++)
            {
                byte c = buf[i];
                if (i != 0)
                    msg += " ";

                msg += $"{c:X2}";

                if (c >= 0x21 && c <= 0x7e)
                    msg +=$"({(char)c})";
                else
                    msg += $"( )";
            }
            msg += "]";
            return msg;
        }


        static bool intTryParse(string value, out int data)
        {
            if (value.StartsWith("0x"))
            {

                if (!int.TryParse(value, System.Globalization.NumberStyles.HexNumber, null, out data))
                {
                    return false;
                }
            }
            else if (!int.TryParse(value, out data))
            {
                return false;
            }

            return true;
        }
        public static bool Str2Hex(string str, out List<byte> buf, out string errMsg)
        {
            errMsg = null;
            Regex regex = new Regex(@"\\(\S)\((\S+)\)");
            buf = new List<byte>();
            string[] ss = str.Split(' ');
            foreach (var s in ss)
            {
                if (s.StartsWith(@"\"))
                {
                    //转义
                    var match = regex.Match(s);
                    if (!match.Success)
                    {
                        //格式出错
                        errMsg = @"转义格式出错。 应该为 \功能号(数值)";
                        return false;
                    }

                    string func = match.Groups[1].Value;
                    string value = match.Groups[2].Value;
                    if (new string[] { "1", "2", "4" }.Contains(func))
                    {
                        if (!intTryParse(value, out int data))
                        {
                            errMsg = $@"不支持转义数值无效 {s}";
                            return false;
                        }
                        if (func == "1")
                            buf.Add((byte)data);
                        else if (func == "2")
                        {
                            byte[] hexs = BitConverter.GetBytes((UInt16)data);
                            buf.AddRange(hexs);
                        }
                        else
                        {
                            byte[] hexs = BitConverter.GetBytes((UInt32)data);
                            buf.AddRange(hexs);
                        }
                        continue;
                    }
                    else if ((func == "S") || (func == "s"))
                    {
                        for (int i = 0; i < value.Length; i++)
                        {
                            byte hex = (byte)value[i];
                            buf.Add(hex);
                        }
                    }
                    else
                    {
                        errMsg = $@"不支持转义 {s}";
                        return false;
                    }
                }
                else
                {
                    if (byte.TryParse(s, System.Globalization.NumberStyles.HexNumber, null, out byte hex))
                    {
                        buf.Add(hex);
                        continue;
                    }

                    //翻译失败

                    for (int i = 0; i < s.Length; i++)
                    {
                        hex = (byte)s[i];
                        buf.Add(hex);
                    }
                }

            }
            return true;
        }
    }
}
